/* 
   Copyright (C) 1997 1998 1999 2000 Dr. Preston B. Moore

Dr. Preston B. Moore
Associate Director, Center for Molecular Modeling (CMM)
University of Pennsylvania, Department of Chemistry, Box 188 
231 S. 34th St. Philadelphia, PA 19104-6323 USA
EMAIL: moore@cmm.chem.upenn.edu  
WWW: http://www.cmm.upenn.edu/~moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


/* functional prototype for energy routines */

void force(SIMPARMS *,COORDS *,INTER *,NGBR *,MYTIMING *,int);
void force_hybrid(SIMPARMS *,COORDS *,INTER *,NGBR *,SO3 *,MYTIMING *,int);
void getvireal(SIMPARMS *,COORDS*,ENERGIES *,INTER *,NGBR *,SO3 *,int);
void geteng(SIMPARMS *,COORDS *,ENERGIES *);
void force_extern(SIMPARMS *,COORDS *,int);
void getvextern(SIMPARMS *,COORDS *,double *,double *,double *,double *,int);
void freeze_atom(SIMPARMS *simparms,COORDS *coords);
void get_p2mt(int natoms,double [],double [],double [],double [],double [9]);
void get_p2mt_select(int natoms,double [],double [],double [],double [],double [9],int *);
void get_cgpot_intern(SIMPARMS *, COORDS *, INTER *);

/*--------------------- md_finter.c -------------------------------*/
void set_exclude(SIMPARMS *simparms,COORDS *coords,INTER *inter,int *);
void force_ter(SIMPARMS *,COORDS *,INTER *inter,NGBR *ngbr,int iflg);
void getvirter(SIMPARMS *,COORDS *,INTER *,NGBR *,double*,double*,double*,
                double [9]);
void fcinter(SIMPARMS *,COORDS *,INTER *,double **);
void fcintern(SIMPARMS *,COORDS *,INTER *,double **);
void get_ngbr(SIMPARMS *,COORDS *,INTER *,NGBR *);
void check_distance(SIMPARMS *,COORDS *,INTER *);
void getnpair(NGBR *);
void nrefsh(SIMPARMS *,COORDS *,INTER *,NGBR *,SO3 *,MYTIMING *);
double pot_inter(double *px,double *py,double *pz);
void allocate_lists(int natoms,int nlen,NGBR *ngbr,COORDS *coords,int *mem);
void free_lists(NGBR *ngbr,COORDS *coords);
void expand_into_aalist(int icg, int jcg, SIMPARMS *simparms, INTER *inter,COORDS *coords,
	NGBR *ngbr, int *inp, int *jnp, int *k, int *ioffs, int *iofft, int *nbreak);

/*-------------------------md_fnopol.c--------------------------*/
void force_npol(SIMPARMS *,COORDS *,int ,int *,int *,int ,int *,INTER *,int);
void vinter_npol(int,int *,int *,int *,double *,double *,double *,double *,
		 int ,int **,double *,double *,double *,int ,
		 double **,double **,double *,double *,double *,
                 double [9],int);
void getsvirter(double *,double *,double *,double [9],int icg);
void getsvirterso3(double *);
void zero_potl(int icg);
void zero_potlso3();
double getvter_intern(SIMPARMS *,COORDS *,INTER *);
void fnonbond_so3(SIMPARMS *,COORDS *,INTER *,SO3 *,int,int *,int *,int);
void fnonbond_so3hr_CGR2HR(SIMPARMS *,COORDS *,int);
void fnonbond_so3hr_HR2CGR(SIMPARMS *,COORDS *,SO3 *,int);
double getvnonbond_so3(SIMPARMS *,COORDS *,INTER *,SO3 *,int,int *,int *,int);

/*--------------------- md_ewald.c -------------------------------*/
void check_distance_e(SIMPARMS *simparms,COORDS *coords,INTER *inter);
void force_ter_e(SIMPARMS *,COORDS *,INTER *,NGBR *,int iflg);
void getvirter_e(SIMPARMS *,COORDS *,INTER *,NGBR *,double*,double*,
		 double[],int);
void ewald_setup(SIMPARMS *,COUL *coul,double *qch,int kmax,double alpha);
void k_ewald(COORDS *coords,double *vkspace);
void fk_ewald(SIMPARMS *,COORDS *);
void getvewald(SIMPARMS *,COORDS *,double *,double *,double [9]);
void ecorr(SIMPARMS *,COORDS *);
void r_ewald(SIMPARMS *simparms,COORDS *coords,double *vrspace);
void fr_ewald(SIMPARMS *simparms,COORDS *coords);

void allocate_lists_e(int ncharge,NGBR *ngbr,int *mem);

/*---------------------finter_e.c------------------------------------*/
void zero_pote(int icg);
void force_e(int ,int ,int *,int *,COORDS *,INTER *,int ,int ,int,int );
void force_e_aa(int ,int ,int *,int *,COORDS *,INTER *,int ,int ,int,int,double *,double *,double *,double);
void vinter_e(int ,int *,int *,COORDS *,INTER *,int iperd,
	      double *spelec,double *spelech,double *swelec,
              double swelectensor[9],int,int,int);
void getsvirter_e(double *velec,double *welec,double welectensor[9],int icg);
void force_dipole(int , double *,double *,double *,double *,double *,double *,
		  double *,double *);

double pot_dipole(int nlen,double *dx,double *dy,double *dz,double *qch,
		  double *alpha);

/*---------------------elec_ngbr.c------------------------------------*/
void count_charge(SIMPARMS *,COORDS *,INTER *,NGBR *,int *,int *);
void set_charges(SIMPARMS *,COORDS *,INTER *,STARTUP *);
int select_charges(int *,COUL *,double *,int);
int select_ecorr(int *,COUL *);
void set_ecorr(SIMPARMS *,COORDS *,int *,int **);
void get_ngbr_e(SIMPARMS *simparms,COORDS *coords,INTER *inter,NGBR *ngbr);
void ngbr_liste(int,int *,int *,int,COORDS *,INTER *,NGBR *,int);
void cnt_ngbr_liste(int,int *,int *,int,COORDS *,INTER *,int *,int *,int);

/* ----------------------set_link.c--------------------------*/
void get_lnklist(int natoms,int ncell,int *head,int *llist,int iperd,
		 double *hmat,double *x,double *y,double *z,
		 int *iaacg,int iflg);
void set_link(SIMPARMS *,NGBR *,double *,double,double);
void get_lnklist_e(int natoms,int ncell,int *head,int *llist,int iperd,
		   double *hmat,double *x,double *y,double *z,double *q,
		   int *iaacg,int iflg);
void count_link_pair(int ncell,int iperd,double hmat[],int ibegin,int iend,
		     int *nvdw,int *nelec,double rmax,double rmaxe);
void update_vlrc(INTER *, int nselect, int *iselect,int ntypes,
			double *vlrc_tot,double *wlrc_tot,int iperd);


/*--------------------- intra molecular energies --------------------------*/
void exclude_bonds(int *,int **,BONDS *);
int select_bonds(int *,BONDS *,int);
void fbond(SIMPARMS *,COORDS *);
void fbond_so3(SIMPARMS *,COORDS *,SO3 *so3,int);
void fbond_hr(SIMPARMS *,COORDS *);
void fbond_so3hr_CGR2HR(SIMPARMS *,COORDS *,int);
void fbond_so3hr_HR2CGR(SIMPARMS *,COORDS *,SO3 *,int);
void getvbond(SIMPARMS *,COORDS *,double *,double *,double [9]);
double getvbond_so3(SIMPARMS *,COORDS *,int);
double getvbond_intern(SIMPARMS *,COORDS *);
double getvbond_intern_CG(SIMPARMS *,COORDS *,int);
void fcbond(COORDS *,double **);
void fcbondn(COORDS *,double **);
double potbond(double *,double *,double *);

void exclude_bends(int *,int **,BENDS *);
int select_bends(int *,BENDS *,int);
void fbend(SIMPARMS *,COORDS *);
void fbend_so3(SIMPARMS *,COORDS *, SO3 *so3,int);
void fbend_hr(SIMPARMS *,COORDS *);
void getvbend(SIMPARMS *,COORDS *,double *,double *,double [9]);
double getvbend_so3(SIMPARMS *,COORDS *,int);
double getvbend_intern(SIMPARMS *,COORDS *);
double getvbend_intern_CG(SIMPARMS *,COORDS *,int);
void fcbend(COORDS *,double **);
void fcbendn(COORDS *,double **);
double potbend(double *,double *,double *);

void exclude_bendquarts(int *,int **,BENDQUART *);
void fbendquart(SIMPARMS *,COORDS *);
void getvbendquart(SIMPARMS *,COORDS *,double *,double *,double [9]);
double potbendquart(double *,double *,double *);

void exclude_tors(int *,int **,TORS *);
int select_tors(int *,TORS *,int);
void ftors(SIMPARMS *,COORDS *);
void ftors_so3(SIMPARMS *,COORDS *, SO3 *so3,int);
void ftors_hr(SIMPARMS *,COORDS *);
void getvtors(SIMPARMS *,COORDS *,double *,double *,double [9]);
double getvtors_so3(SIMPARMS *,COORDS *,int);
double getvtors_intern(SIMPARMS *,COORDS *);
double getvtors_intern_CG(SIMPARMS *,COORDS *,int);
void fctors(COORDS *,double **);
void fctorsn(COORDS *,double **);
double pottors(double *,double *,double *);

void exclude_onfo(int *,int **,ONFO *);
int select_onfos(int *,ONFO *,int);
void fonfo(SIMPARMS *,COORDS *);
void fonfo_so3(SIMPARMS *,COORDS *, SO3 *so3,int);
void fonfo_hr(SIMPARMS *,COORDS *);
void getvonfo(SIMPARMS *,COORDS *,double*,double*,double*,double*,
               double [9],double [9]);
void getvonfo_so3(SIMPARMS *,COORDS *,int,double *,double *);
void getvonfo_intern(SIMPARMS *,COORDS *,double *,double *);
void getvonfo_intern_CG(SIMPARMS *,COORDS *,double *,double *,int);
void fconefour(COORDS *,double **);
void fconefourn(COORDS *,double **);
double pot_onefour(double *,double *,double *);

void fbondx(SIMPARMS *,COORDS *);
void fbondx_so3(SIMPARMS *,COORDS *, SO3 *so3,int);
void fbondx_hr(SIMPARMS *,COORDS *);
int select_bondxs(int *,BONDXS *,int);
void getvbondx(SIMPARMS *,COORDS *,double *,double *,double [9]);
double getvbondx_intern(SIMPARMS *,COORDS *);
double getvbondx_intern_CG(SIMPARMS *,COORDS *,int);
void fcbondx(COORDS *,double **);
void fcbondxn(COORDS *,double **);
double potbondx(double *,double *,double *);

/*---------------------- md_funcvdw.c -----------------------------*/
void func_lj(double,double *,double *,double *,double,double);
void func_will(double,double*,double*,double*,
	       double,double,double,double,double);
void func_aziz(double ,double *,double *,double *,double ,double ,
	       double ,double ,double ,double ,double ,double ,double);
void func_hydbnd(double ,double *,double *,double *,double ,double );
void func_kerf(double ,double *,double *,double *,double );
void func_coul(double ,double *,double *,double *);
void func_hautman(double x,double *f,double *df,double *d2f,
		  double zmin,double c12,double c3);
void func_lj64(double,double *,double *,double *,double,double);
void func_lj96(double,double *,double *,double *,double,double);
void func_tab_pot(FILE *, double ,double *,double *,double *);

/*------------------------ md_subspace.c ---------------------------*/
void diagonalize(double **,int,double*,double,double,int*,int*,int);
void find_zeros(int ,double *,int *,int *,int *);
void pack(SUBSPACE *,int, int,double *,double **);
void pack_d2v(int,SUBSPACE*,int,double**,double*,double**,double*,int*,int);

void get_subspace(SIMPARMS *simparms,COORDS *coords,INTER *,
		  double *x2,double *y2,double *z2,SUBSPACE *subspace);
void get_subvec(SIMPARMS *,COORDS *,INTER *,SUBSPACE *);
void get_grp_fcmat(int,int*,int,int*,double**,SUBSPACE*,int*,double***);

/*---------------------- md_nmafcntr.c -----------------------------*/
void fmat(SIMPARMS *simparms,COORDS *coords,INTER *inter,NMODES *nmodes);
void copy(int ,int ,double **,int ,int,double **,int ,int );
void get_axis(int,int,int*,int*,COORDS *,double**);
void overper(int ,int,int*,int*,double **,double **,double **);

/*----------------------- friciton.c ----------------------------------*/
void friction(SIMPARMS *simparms,COORDS *coords,INTER *inter,NMODES *nmodes);

/*----------------------- md_spectrum ---------------------------------*/
void avg_spec(int natoms,NMODES *nmodes);
void get_spectrum(int ,double *,double *,double **,double *,double **);
void get_specq(int ,double *,double *,double **,double *);
void get_spect_full(int ,double *,double *,double **,double *,double **);

/* ------------------------hills---------------------------------------*/

void fcolvar_cntr(SIMPARMS *,COORDS *,int force_flag);
void hills(SIMPARMS *simparms,COORDS *coords);
void add_hills(COLVAR *colvar, int istep);
