/* 
   Copyright (C) 1997 1998 1999 2000 Dr. Preston B. Moore

Dr. Preston B. Moore
Associate Director, Center for Molecular Modeling (CMM)
University of Pennsylvania, Department of Chemistry, Box 188 
231 S. 34th St. Philadelphia, PA 19104-6323 USA
EMAIL: moore@cmm.chem.upenn.edu  
WWW: http://www.cmm.upenn.edu/~moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* prototypes for hybrid all atom/ coarse grain routines */

/* ------------- coarse grain <--> all atom transformations ---- */
/* ---------------------------- aacg_mapping.c ---------------- */
void allocate_hybrid_lists(SIMPARMS *);
void set_aaselection(int, int, int *, int *);
void get_cgpos(COORDS *,int **, int *,int,int *);
void get_cgcom(SIMPARMS *,COORDS *,COORDS *);
void get_cgvelcom(SIMPARMS *,COORDS *,COORDS *);
void check_aa_com(double *,double *,double *,double *,int **, int *, int ,int, int);
void get_cgvel(COORDS *,int **, int *,int,int *);
void get_relat_aapos(COORDS *,int **, int *, int *,int);
void get_abs_aapos(COORDS *,int **, int *, int *,int);
void get_relat_aavel(COORDS *,int **, int *, int *,int);
void get_abs_aavel(COORDS *,int **, int *, int *,int);
void distribute_cgvel_over_aa(COORDS *,int **, int *);
void distribute_cgaccel(double *,double,int,int,int *,int *,int ,double *);
int select_atoms(int *,int *,COORDS *);
void swap_active2healing(COORDS *coords, int iatom, int ifind);
void activate_atom(COORDS *coords, int iatom, int ifind);
void deactivate_atom(COORDS *coords, int iatom, int ifind);
void distribute_force_over_aa(COORDS *,int **,int *,double *,double *);
void set_switchfunction(SIMPARMS *,COORDS *);
int get_healingregion(SIMPARMS *,COORDS *,SO3 *,int);
void select_hybridregions(SIMPARMS *, COORDS *, INTER *,NGBR *,SO3 *,int,int);
int get_so3opt_region(SIMPARMS *,COORDS *);
void so3_optimization(SIMPARMS *, COORDS *,char *);

/* --------------------- split_structs_in_two.c ----------------- */
void split_ngbr_in_two(int ncg, int naa, NGBR *);
void split_inter_in_two(int ncg, int naa, int ntype, int ncgtype, INTER *,int);
void split_coords_in_two(int ncg, int naa, int *, COORDS *,int *,int,int,int);
void select_ewald(COORDS *coords);
void split_energies_in_two(ENERGIES *energies);

/*----------------------------------cgaaso3.c ------------------------*/
void getOmegaInit(SIMPARMS *,COORDS *,SO3 *);
void getOmegaInit_CG(SIMPARMS *,COORDS *,SO3 *,int);
void getMitAA(SIMPARMS *,COORDS *,SO3 *);
void getTorqueAA(SIMPARMS *,COORDS *,SO3 *,double *,int);
void getAlphaInit(SO3 *,int,int *);
void getAlphaInc(SO3 *so3,int,int *);
void UpdateOmega(SIMPARMS *, SO3 *,int,int *,double);
void UpdateSO3Coords(SIMPARMS *, COORDS *, SO3 *,double);
void DistributeAlphaAA(SIMPARMS *,COORDS *,SO3 *,double *,int ,int *);
void energyso3(SIMPARMS *,COORDS *, ENERGIES *, INTER *, NGBR *, SO3 *);
void intso3(SIMPARMS *,COORDS *, ENERGIES *, INTER *, NGBR *, SO3 *);
double get_so3_ekin(double omega[3], double mit[3][3]);

/*----------------------------------mnewt.c ------------------------*/
void getAccel(int,int *,SO3 *,double,int); 

